import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Ball here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Ball extends Actor {
    private double gravity = 0.0981;
    double[] velocity = {Greenfoot.getRandomNumber(21)-10, 0};
    double[] loc;
    double turning = 0;
    double rot = 0;
    
    public Ball() {
        GreenfootImage img = new GreenfootImage(40, 40);
        int r = Greenfoot.getRandomNumber(101);
        int b = Greenfoot.getRandomNumber(101-r);
        int g = 100-(b+r);
        img.setColor(new Color((int)(2.55*r), (int)(2.55*g), (int)(2.55*b)));
        img.fillOval(0, 0, 39, 39);
        img.setColor(Color.BLACK);
        img.drawOval(0, 0, 39, 39);
        img.drawLine(0, 20, 40, 20);
        img.drawLine(20, 0, 20, 40);
        setImage(img);
    }
    
    public void addedToWorld(World world) {
        loc = new double[] {getX(), getY()};
    }
    
    public void act() {
        Goat goat = (Goat)getOneIntersectingObject(Goat.class);
        Ball ball = (Ball)getOneIntersectingObject(Ball.class);
        velocity[1] += gravity;
        if(ball!=null) {
            double xDiff = ball.loc[0]-loc[0];
            double yDiff = ball.loc[1]-loc[1];
            double dist = Math.sqrt(xDiff*xDiff+yDiff*yDiff);
            double norm = Math.toDegrees(Math.atan2(yDiff, xDiff));
            double dir = Math.toDegrees(Math.atan2(velocity[1], velocity[0]));
            double mag = Math.sqrt(velocity[0]*velocity[0]+velocity[1]*velocity[1]);
            double diff = dir-norm;
            double nMag = mag;
            if(nMag < 0.5) nMag = 0;
            else if((180+(norm-diff))%360>180) nMag = nMag/5*4;
            if(dist<=40) {
                velocity[0] = Math.cos(Math.toRadians(180+(norm-diff)))*nMag;
                velocity[1] = Math.sin(Math.toRadians(180+(norm-diff)))*nMag;
            }
            if(dist<40) loc = new double[] {ball.loc[0]+Math.cos(Math.toRadians((norm+180)%360))*40, ball.loc[1]+Math.sin(Math.toRadians((norm+180)%360))*40};
        }
        if(loc[0] < getImage().getWidth()/2 || loc[0] >= getWorld().getWidth()-getImage().getWidth()/2 || 
        (goat!=null && !goat.inAir && (loc[0] < goat.getX()+goat.getImage().getWidth()/2+getImage().getWidth()/2 ||
        loc[0] >= goat.getX()-goat.getImage().getWidth()/2-getImage().getWidth()/2))) {
            velocity[0] = -(velocity[0]/5*3);
            if(goat!=null) {
                velocity[0] += goat.velocity[0];
                if(Math.abs(goat.velocity[0]) > 0) velocity[1] -= Math.abs(goat.velocity[0])*2;
            }
        }
        if(loc[1] < getImage().getHeight()/2 || loc[1] >= getWorld().getHeight()-getImage().getHeight()/2 ||
        (goat!=null && (loc[1] < goat.getY()+goat.getImage().getHeight()/2+getImage().getHeight()/2 ||
        loc[1] >= goat.getY()-goat.getImage().getHeight()/2-getImage().getHeight()/2))) {
            if(goat!=null && goat.inAir) {
                velocity[1] += goat.velocity[1]*0.5;
                if(goat.flip) velocity[0] += Greenfoot.getRandomNumber(15);
                else velocity[0] -= Greenfoot.getRandomNumber(15);
            } else {
                velocity[1] = gravity-(velocity[1]-gravity)/5*3;
                if(velocity[1] > -0.0007 && velocity[1] <= 0) velocity[1] = 0;
                if(Math.abs(velocity[0]) >= 0.0005) {
                    if(velocity[0] > 0) velocity[0] -= 0.005;
                    else velocity[0] += 0.005;
                } else velocity[0] = 0;
                if(goat!=null) velocity[1] += goat.velocity[1];
            }
        }
        if(goat!=null && !goat.inAir && loc[1] < goat.getY()+goat.getImage().getHeight()/2+getImage().getHeight()/2 && loc[1] >= goat.getY()) loc[1] = goat.getY()+goat.getImage().getHeight()/2+getImage().getHeight()/2;
        if(goat!=null && !goat.inAir && loc[0] < goat.getX()+goat.getImage().getWidth()/2+getImage().getWidth()/2 && loc[0] > goat.getX()+goat.getImage().getWidth()/2) loc[0] = goat.getX()+goat.getImage().getWidth()/2+getImage().getWidth()/2;
        if(goat!=null && !goat.inAir && loc[0] > goat.getX()-goat.getImage().getWidth()/2-getImage().getWidth()/2 && loc[0] < goat.getX()-goat.getImage().getWidth()/2) loc[0] = goat.getX()-goat.getImage().getWidth()/2-getImage().getWidth()/2;
        if(goat!=null && !goat.inAir && loc[1] > goat.getY()-goat.getImage().getHeight()/2-getImage().getHeight()/2 && loc[1] < goat.getY()) loc[1] = goat.getY()-goat.getImage().getHeight()/2-getImage().getHeight()/2;
        if(loc[1] < getImage().getHeight()/2-1) loc[1] = getImage().getHeight()/2-1;
        if(loc[0] < getImage().getWidth()/2-1) loc[0] = getImage().getWidth()/2-1;
        if(loc[0] > getWorld().getWidth()-getImage().getWidth()/2) loc[0] = getWorld().getWidth()-getImage().getWidth()/2;
        if(loc[1] > getWorld().getHeight()-getImage().getHeight()/2) loc[1] = getWorld().getHeight()-getImage().getHeight()/2;
    }
    
    public void doStuff() {
        turning = 360*velocity[0]/(40*Math.PI);
        loc[0] += velocity[0];
        loc[1] += velocity[1];
        setLocation((int)loc[0], (int)loc[1]);
        rot += turning;
        setRotation((int)rot);
    }
}
